## mobilitydb 1.1.1

=== CMakeLists.txt ===
#-------------------------------------
# MobilityDB/MEOS Main CMake file
#-------------------------------------

# Minimum Cmake version supporting fixtures
cmake_minimum_required(VERSION 3.7)

# Disallow in-source builds
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed.
  Please make a new directory (called a build directory) and run CMake from there.
  You may need to remove 'CMakeCache.txt' and 'CMakeFiles/'.")
endif()

# Set a default build type if none was specified
# https://www.kitware.com/cmake-and-the-default-build-type/
set(default_build_type "Release")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Specify search path for CMake modules to be loaded
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(CheckSymbolExists)
include(CheckCXXSymbolExists)
include(CheckCSourceRuns)

#-------------------------------------
# RPATH settings
# https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
#-------------------------------------

# use, i.e. don't skip the full RPATH for the build tree
# set(CMAKE_SKIP_BUILD_RPATH FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
# set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

# set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
# set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
# list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
# if("${isSystemDir}" STREQUAL "-1")
    # set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
# endif("${isSystemDir}" STREQUAL "-1")

#-------------------------------------
# MobilityDB definitions
#-------------------------------------

# Windows build with MSVC

if(CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022")
  message(STATUS "Setting options for Visual Studio")
  set(MSVC 1)
  # Disable native language support
  add_definitions(-DENABLE_NLS=0)
  # Disable warning C4996: 'strcpy': This function or variable may be unsafe.
  add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)
endif()

# Option for including network points
option(MEOS
  "Set MEOS (default=OFF) to build the MEOS library instead of the MobilityDB
  PostgreSQL extension
  "
  OFF
)

if(NOT MEOS)
  # Option for including network points
  option(NPOINT
    "Set ON|OFF (default=ON) to include network points
    "
    ON
  )
else()
  # Set NPOINT option for excluding support for network points, which require a
  # table named `ways` containing the geometries of the road network
  set(NPOINT OFF)
endif()

if(NPOINT)
  message(STATUS "Including network points")
  add_definitions(-DNPOINT=1)
else()
  message(STATUS "Excluding network points")
  add_definitions(-DNPOINT=0)
endif()

# Get the MobilityDB major/minor/micro versions from the text file
file(READ mobdb_version.txt ver)
string(REGEX MATCH "MOBILITYDB_MAJOR_VERSION=([0-9]+)" _ ${ver})
set(MOBILITYDB_MAJOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "MOBILITYDB_MINOR_VERSION=([0-9]+)" _ ${ver})
set(MOBILITYDB_MINOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "MOBILITYDB_MICRO_VERSION=([0-9]+)" _ ${ver})
set(MOBILITYDB_MICRO_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "MOBILITYDB_MICRO_VERSION=[0-9]+(beta?[0-9]+)" _ ${ver})
set(PROJECT_VERSION_DEV ${CMAKE_MATCH_1})

# Set the project name and project version
project(MobilityDB VERSION ${MOBILITYDB_MAJOR_VERSION}.${MOBILITYDB_MINOR_VERSION}.${MOBILITYDB_MICRO_VERSION})
message(STATUS "Building MobilityDB version ${PROJECT_VERSION}")
# Enable testing, must follow project() call above
include(CTest)
# Make CTest run verbose for the output of the failed tests
set(CMAKE_CTEST_ARGUMENTS "--output-on-failure")
enable_testing()

set(MOBILITYDB_VERSION "${PROJECT_VERSION}")
set(MOBILITYDB_VERSION_STRING "${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}${PROJECT_VERSION_DEV}")
add_definitions(-DMOBILITYDB_VERSION_STRING="${MOBILITYDB_VERSION_STRING}")

# Comment out code used for debugging purposes so it is not concerned by the coverage
if(CMAKE_BUILD_TYPE MATCHES Debug)
  message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
  add_definitions(-DDEBUG_BUILD)
endif()

#-------------------------------------
# Set compiler flags
#-------------------------------------

# Generate position-independent code (PIC)
include(CheckCCompilerFlag)
if(NOT WIN32)
  CHECK_C_COMPILER_FLAG("-fPIC" C_COMPILER_SUPPORTS_FPIC)
  if(C_COMPILER_SUPPORTS_FPIC)
    message(STATUS "Compiling into position-independent code (PIC)")
    add_definitions(-fPIC)
  endif()
endif()

# FFSL functions for finding the first (least significant) bit
check_symbol_exists(ffsl "string.h" HAS_FFSL)
if(NOT HAS_FFSL)
  message(STATUS "No ffsl functions provided")
  add_definitions(-DNO_FFSL)
endif()

# TODO
# Reentrant (_r) functions for POSIX hash table management (e.g. hsearch)
# check_symbol_exists("hsearch_r" "search.h" HAS_HSEARCH_R)
# if(NOT HAS_HSEARCH_R)
  # add_definitions(-DNO_HSEARCH_R)
# endif()

# Added to build on Windows to avoid the error 'M_PI': undeclared identifier
add_compile_definitions(_USE_MATH_DEFINES)

# Set default compile flags and code coverage for GCC
if(CMAKE_COMPILER_IS_GNUCC)
  # MobilityDB compiler flags
  add_definitions(-Wall -Wextra -std=gnu1x -Wunused-parameter -Wno-strict-aliasing)
  # -Wno-strict-aliasing was removed to access directly PostGIS points
  # See file tpoint_spatialfuncs.h
  # add_definitions(-Wall -Wextra -std=gnu1x -Wno-unused-parameter)
  # Code coverage
  if(WITH_COVERAGE)
    message(STATUS "Generating code coverage")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage")
  endif()
endif()

# Set compiler optimizations for release
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2")
# Disable compiler optimizations for debugging
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0")

# Check machine architecture: big endian vs. little endian
# Needed for WKB support in MobilityDB and PostGIS (file postgis_config.h.in)
include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
  message(STATUS "BIG_ENDIAN")
  add_definitions(-DMEOS_IS_BIG_ENDIAN=1)
  set(DEF_WORDS_BIGENDIAN ON)
else()
  message(STATUS "LITTLE_ENDIAN")
  add_definitions(-DMEOS_IS_BIG_ENDIAN=0)
  unset(DEF_WORDS_BIGENDIAN)
endif()

# check for needed Header files and functions
set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(strchrnul "string.h" HAVE_STRCHRNUL)
unset(CMAKE_REQUIRED_DEFINITIONS)
check_symbol_exists(__get_cpuid "cpuid.h" HAVE__GET_CPUID)
check_c_source_runs("
#include <stdint.h>
int main() {
    uint64_t x = 1, r;
    __asm__ (\"popcntq %1, %0\" : \"=r\"(r) : \"r\"(x));
    return 0;
}" HAVE_X86_64_POPCNTQ)

#--------------------------------
# Other dependencies
#--------------------------------

# GEOS geometry library
find_package(GEOS REQUIRED)
include_directories(SYSTEM ${GEOS_INCLUDE_DIR})
math(EXPR POSTGIS_GEOS_VERSION "${GEOS_VERSION_MAJOR} * 10 + ${GEOS_VERSION_MINOR}")
message(STATUS "POSTGIS_GEOS_VERSION: ${POSTGIS_GEOS_VERSION}")

# Proj reprojection library
find_package(PROJ REQUIRED)
include_directories(SYSTEM ${PROJ_INCLUDE_DIRS})
math(EXPR POSTGIS_PROJ_VERSION "${PROJ_VERSION_MAJOR} * 10 + ${PROJ_VERSION_MINOR}")
message(STATUS "POSTGIS_PROJ_VERSION: ${POSTGIS_PROJ_VERSION}")
add_definitions(-DPROJ_VERSION_STRING="${POSTGIS_PROJ_VERSION}")

# JSON-C library (used for MF-JSON input/output)
find_package(JSON-C REQUIRED)
include_directories(SYSTEM ${JSON-C_INCLUDE_DIRS})

# GSL (GNU Scientific Library) (used for skiplists)
find_package(GSL REQUIRED)
include_directories(SYSTEM ${GSL_INCLUDE_DIRS})
message(STATUS "GSL_VERSION: ${GSL_VERSION}")
add_definitions(-DGSL_VERSION_STRING="${GSL_VERSION}")

#-------------------------------------
# Build either MobilityDB or MEOS
#-------------------------------------

if(MEOS)
  add_subdirectory(meos)
else()
  add_subdirectory(mobilitydb)
endif()

#-----------------------------------------------------------------------------
# Documentation
#-----------------------------------------------------------------------------

add_subdirectory(doc)
add_subdirectory(doxygen)

#-----------------------------------------------------------------------------
# The End
#-----------------------------------------------------------------------------

=== meos/CMakeLists.txt ===
#-------------------------------------
# MEOS CMake file
#-------------------------------------

message(STATUS "-------------------------")
message(STATUS "Building the MEOS library")
message(STATUS "-------------------------")

# Set MEOS option for building the MEOS library
set(MEOS ON)

# Enable code specific to MEOS, typically user-oriented wrapper functions
# hiding internal implementation details from the API. Such functions are
# not used in the MobilityDB PostgreSQL extension.
add_definitions(-DMEOS=1)

# Set the version and name of the MEOS library
set(MEOS_LIB_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
set(MEOS_LIB_NAME "meos")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# Set the location of the directory of the time zone database
add_definitions(-DSYSTEMTZDIR="/usr/share/zoneinfo")
message(STATUS "Directory of the time zone database: /usr/share/zoneinfo")

# Option to show debug messages for analyzing the expandable data structures
option(DEBUG_EXPAND
  "Set DEBUG_EXPAND (default=OFF) to show debug messages for analyzing the
  expandable data structures
  "
  OFF
)

if(DEBUG_EXPAND)
  add_definitions(-DDEBUG_EXPAND=1)
  message(STATUS "Showing debug messages for expandable data structures")
endif()


#-----------------------------------------
# Set default PostgreSQL Version for MEOS
#-----------------------------------------

set(POSTGRESQL_VERSION_STRING "PostgreSQL 14.2")
set(POSTGRESQL_VERSION_NUMBER "140200")
set(POSTGRESQL_VERSION_MAJOR "14")
set(POSTGRESQL_VERSION_MINOR "2")

# MobilityDB definitions for PostgreSQL version-dependent code
add_definitions(-DPOSTGRESQL_VERSION_STRING="${POSTGRESQL_VERSION_STRING}")
add_definitions(-DPOSTGRESQL_VERSION_NUMBER=${POSTGRESQL_VERSION_NUMBER})

#--------------------------------------
# Set default PostGIS Version for MEOS
#--------------------------------------

set(POSTGIS_VERSION_STRING "PostGIS 3.2.1")
set(POSTGIS_VERSION_NUMBER "30201")

# PostGIS definitions for PostgreSQL and PostGIS version-dependent code
# use POSTGRESQL_VERSION_NUMBER instead of the original POSTGIS_PGSQL_VERSION

add_definitions(-DPOSTGIS_VERSION_STRING="${POSTGIS_VERSION_STRING}")
add_definitions(-DPOSTGIS_VERSION_NUMBER=${POSTGIS_VERSION_NUMBER})

#--------------------------------
# MobilityDB directories
#--------------------------------

# PostGIS
configure_file(${CMAKE_SOURCE_DIR}/postgis/postgis_config.h.in ${CMAKE_SOURCE_DIR}/postgis/postgis_config.h)
include_directories("${CMAKE_SOURCE_DIR}/postgis/liblwgeom")
include_directories("${CMAKE_SOURCE_DIR}/postgis")
add_subdirectory("${CMAKE_SOURCE_DIR}/postgis" "postgis")

# PostgreSQL
configure_file(${CMAKE_SOURCE_DIR}/meos/postgres/pg_config.h.in ${CMAKE_SOURCE_DIR}/meos/postgres/pg_config.h)
include_directories("postgres")
add_subdirectory("postgres")
# Disable all warnings on embedded code from PostgreSQL
if(CMAKE_GENERATOR STREQUAL "Unix Makefiles")
  target_compile_options(timezone PRIVATE "-w")
  target_compile_options(utils PRIVATE "-w")
endif()

# MEOS
include_directories("include")
add_subdirectory("src")

# Must be after add_library
if(CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022")
  # Disable all warnings on embedded code from PostgreSQL and PostGIS
  target_compile_options(liblwgeom PRIVATE "/W0")
  target_compile_options(libpgcommon PRIVATE "/W0")
  target_compile_options(ryu PRIVATE "/W0")
  # Enable all warnings on MEOS and MobilityDB
  target_compile_options(general PRIVATE "/W4")
  target_compile_options(point PRIVATE "/W4")
  target_compile_options(npoint PRIVATE "/W4")
endif()

#--------------------------------
# Build MEOS library
#--------------------------------

# Customize the meos.in.h and meos_internal.in.h files for external include with MEOS library
# Read files
file(READ "${CMAKE_SOURCE_DIR}/meos/include/meos.h" MEOS_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/meos_internal.h" MEOS_INTERNAL_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/postgres_ext_defs.in.h" POSTGRES_EXT_DEFS_IN_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/postgis_ext_defs.in.h" POSTGIS_EXT_DEFS_IN_H)
# Generate meos_export.h
string(REGEX REPLACE "#if MEOS\n#include \"postgres_int_defs.h\"\n#else\n#include <postgres.h>\n#include <utils/date.h>\n#include <utils/timestamp.h>\n#endif" "${POSTGRES_EXT_DEFS_IN_H}" MEOS_EXP_1_H "${MEOS_H}")
string(REGEX REPLACE "#include <liblwgeom.h>" "${POSTGIS_EXT_DEFS_IN_H}" MEOS_EXP_2_H "${MEOS_EXP_1_H}")
file(WRITE "${CMAKE_BINARY_DIR}/meos_export.h" "${MEOS_EXP_2_H}")
# Generate meos_internal_export.h
string(REGEX REPLACE "#include \"general/meos_catalog.h\"" "#include \"meos_catalog.h\"" MEOS_INTERNAL_EXP_H "${MEOS_INTERNAL_H}")
file(WRITE "${CMAKE_BINARY_DIR}/meos_internal_export.h" "${MEOS_INTERNAL_EXP_H}")

# MEOS
set(PROJECT_OBJECTS "$<TARGET_OBJECTS:general>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:point>")
if(MEOS)
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:general_meos>")
endif()
if(NPOINT)
  message(STATUS "Including network points")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:npoint>")
endif()

# PostgreSQL
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:common>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:port>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:timezone>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:utils>")

# Build the library: PostGIS
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:liblwgeom>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:ryu>")

# Build the library: All
add_library(${MEOS_LIB_NAME} SHARED ${PROJECT_OBJECTS})
if(APPLE)
  set_target_properties(${MEOS_LIB_NAME} PROPERTIES
    LINK_FLAGS "-Wl,-undefined,dynamic_lookup")
endif()

#--------------------------------
# Specify libraries to link
#--------------------------------

target_link_libraries(${MEOS_LIB_NAME} ${JSON-C_LIBRARIES})
target_link_libraries(${MEOS_LIB_NAME} ${GEOS_LIBRARY})
target_link_libraries(${MEOS_LIB_NAME} ${PROJ_LIBRARIES})
target_link_libraries(${MEOS_LIB_NAME} ${GSL_LIBRARY})
target_link_libraries(${MEOS_LIB_NAME} ${GSL_CBLAS_LIBRARY})

#--------------------------------
# Belongs to MEOS
#--------------------------------

if(APPLE AND ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
  install(FILES "${CMAKE_BINARY_DIR}/meos_export.h"
    DESTINATION "/opt/homebrew/include"
    RENAME "meos.h")
  install(
    FILES "${CMAKE_BINARY_DIR}/meos_internal_export.h"
    DESTINATION "/opt/homebrew/include"
    RENAME "meos_internal.h")
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/include/general/meos_catalog.h"
    DESTINATION "/opt/homebrew/include")
  install(TARGETS ${MEOS_LIB_NAME} DESTINATION "/opt/homebrew/lib")
  message(STATUS "Building MEOS:")
  message(STATUS "  Library file: '/opt/homebrew/lib'")
  message(STATUS "  Include file: '/opt/homebrew/include'")
else()
  install(
    FILES "${CMAKE_BINARY_DIR}/meos_export.h"
    DESTINATION "/usr/local/include"
    RENAME "meos.h")
  install(
    FILES "${CMAKE_BINARY_DIR}/meos_internal_export.h"
    DESTINATION "/usr/local/include"
    RENAME "meos_internal.h")
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/include/general/meos_catalog.h"
    DESTINATION "/usr/local/include")
  install(TARGETS ${MEOS_LIB_NAME} DESTINATION "/usr/local/lib")
  message(STATUS "Building MEOS:")
  message(STATUS "  Library file: '/usr/local/lib'")
  message(STATUS "  Include file: '/usr/local/include'")
endif()

#-----------------------------------------------------------------------------
# Documentation
#-----------------------------------------------------------------------------


#-----------------------------------------------------------------------------
# The End
#-----------------------------------------------------------------------------

=== mobilitydb/CMakeLists.txt ===
#-------------------------------------
# MobilityDB CMake file
#-------------------------------------

message(STATUS "-------------------")
message(STATUS "Building MobilityDB")
message(STATUS "-------------------")

# Disable code specific to MEOS which is not used in the MobilityDB PostgreSQL
# extension.
add_definitions(-DMEOS=0)

# Set the version and name of the library
set(MOBILITYDB_LIB_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
set(MOBILITYDB_LIB_NAME "${CMAKE_PROJECT_NAME}-${MOBILITYDB_LIB_VERSION}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# Set the name of the PostgreSQL extension
string(TOLOWER ${CMAKE_PROJECT_NAME} MOBILITYDB_LOWERCASE_NAME)
set(MOBILITYDB_EXTENSION_FILE "${MOBILITYDB_LOWERCASE_NAME}--${PROJECT_VERSION}.sql")

# Comment out code used for debugging purposes so it is not concerned by the coverage
if(CMAKE_BUILD_TYPE MATCHES Debug)
  message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
  add_definitions(-DDEBUG_BUILD)
endif()

# Option to show debug messages for analyzing the selectivity estimation
option(DEBUG_SELECTIVITY
  "Set DEBUG_SELECTIVITY (default=OFF) to show debug messages for analyzing the
  selectivity estimation
  "
  OFF
)

if(DEBUG_SELECTIVITY)
  add_definitions(-DDEBUG_SELECTIVITY=1)
  message(STATUS "Showing debug messages for selectivity estimation")
endif()

#-------------------------------------
# Get PostgreSQL Version
#-------------------------------------

# Find PostgreSQL
set(PG_MIN_MAJOR_VERSION "12")
set(PG_MAX_MAJOR_VERSION "14")
find_package(POSTGRESQL ${PG_MIN_MAJOR_VERSION} REQUIRED)
if(NOT POSTGRES_VERSION VERSION_LESS PG_MAX_MAJOR_VERSION)
  message(FATAL_ERROR "Not supporting PostgreSQL ${POSTGRESQL_VERSION}")
endif()

include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR})
if(WIN32)
  include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR}/port/win32)
  if(MSVC)
    include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR}/port/win32_msvc/)
  endif()
  link_directories(${POSTGRESQL_LIBRARIES})
  link_libraries(postgres)
endif()

# MobilityDB definitions for PostgreSQL version-dependent code
add_definitions(-DPOSTGRESQL_VERSION_STRING="${POSTGRESQL_VERSION_STRING}")
add_definitions(-DPOSTGRESQL_VERSION_NUMBER=${POSTGRESQL_VERSION_NUMBER})

#-------------------------------------
# Get PostGIS Version
#-------------------------------------

find_package(POSTGIS REQUIRED)

# PostGIS definitions for PostgreSQL and PostGIS version-dependent code
# use POSTGRESQL_VERSION_NUMBER instead of the original POSTGIS_PGSQL_VERSION

add_definitions(-DPOSTGIS_VERSION_STRING="${POSTGIS_VERSION_STR}")
add_definitions(-DPOSTGIS_VERSION_NUMBER=${POSTGIS_VERSION_NUMBER})

#--------------------------------
# MobilityDB directories
#--------------------------------

# Embed PostGIS 3
configure_file(${CMAKE_SOURCE_DIR}/postgis/postgis_config.h.in ${CMAKE_SOURCE_DIR}/postgis/postgis_config.h)
include_directories("${CMAKE_SOURCE_DIR}/postgis/liblwgeom")
include_directories("${CMAKE_SOURCE_DIR}/postgis/libpgcommon")
include_directories("${CMAKE_SOURCE_DIR}/postgis")
add_subdirectory("${CMAKE_SOURCE_DIR}/postgis" "postgis")

# MEOS
include_directories("${CMAKE_SOURCE_DIR}/meos/include")
add_subdirectory("${CMAKE_SOURCE_DIR}/meos/src" "meos_src")

# MobilityDB
include_directories("pg_include")
add_subdirectory("src")

# Must be after add_library
if(CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022")
  # Disable all warnings on embeded code from PostgreSQL and PostGIS
  target_compile_options(liblwgeom PRIVATE "/W0")
  target_compile_options(libpgcommon PRIVATE "/W0")
  target_compile_options(ryu PRIVATE "/W0")
  # Enable all warnings on MEOS and MobilityDB
  target_compile_options(general PRIVATE "/W4")
  target_compile_options(point PRIVATE "/W4")
  target_compile_options(npoint PRIVATE "/W4")
  target_compile_options(pg_general PRIVATE "/W4")
  target_compile_options(pg_point PRIVATE "/W4")
  target_compile_options(pg_npoint PRIVATE "/W4")
endif()

#--------------------------------
# Build MobilityDB library
#--------------------------------

# MEOS
set(PROJECT_OBJECTS "$<TARGET_OBJECTS:general>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:point>")
if(NPOINT)
  message(STATUS "Including network points")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:npoint>")
endif()

# Build the library: PostGIS
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:liblwgeom>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:libpgcommon>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:ryu>")

# MobilityDB
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_general>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_point>")
if(NPOINT)
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_npoint>")
endif()

# Build the library
add_library(${MOBILITYDB_LIB_NAME} MODULE ${PROJECT_OBJECTS})
if(APPLE)
  If(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
    message(STATUS "Building for arm architecture")
    set_target_properties(${MOBILITYDB_LIB_NAME} PROPERTIES
    LINK_FLAGS "-Wl,-undefined,dynamic_lookup -bundle_loader /opt/homebrew/bin/postgres")
  else()
    message(STATUS "Building for x86 architecture")
    set_target_properties(${MOBILITYDB_LIB_NAME} PROPERTIES
    LINK_FLAGS "-Wl,-undefined,dynamic_lookup -bundle_loader /usr/local/bin/postgres")
  endif()
endif()

#--------------------------------
# Specify libraries to link
#--------------------------------

target_link_libraries(${MOBILITYDB_LIB_NAME} ${JSON-C_LIBRARIES})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${LWGEOM_LIBRARIES})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${GSL_LIBRARY})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${GSL_CBLAS_LIBRARY})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${GEOS_LIBRARY})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${PROJ_LIBRARIES})
if(WIN32)
  message(STATUS "Adding PostGIS as a target link library")
  target_link_libraries(${MOBILITYDB_LIB_NAME} ${POSTGIS_LIBRARY})
endif()

#--------------------------------
# Belongs to MobilityDB
#--------------------------------

message(STATUS "Including SQL definitions and tests")
add_subdirectory(sql)
add_subdirectory(test)
add_custom_target(sqlscript ALL DEPENDS ${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE})
add_custom_target(control ALL DEPENDS ${CMAKE_BINARY_DIR}/mobilitydb.control)
install(
  FILES "${CMAKE_BINARY_DIR}/mobilitydb.control" "${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}"
  DESTINATION "${POSTGRESQL_SHARE_DIR}/extension")
install(TARGETS ${MOBILITYDB_LIB_NAME} DESTINATION "${POSTGRESQL_DYNLIB_DIR}")

#-----------------------------------------------------------------------------
# The End
#-----------------------------------------------------------------------------

=== meos/src/CMakeLists.txt ===
add_subdirectory(general)
add_subdirectory(point)
if(NPOINT)
  add_subdirectory(npoint)
endif()

=== mobilitydb/sql/CMakeLists.txt ===
set(MOBILITYDB_MODULE_PATHNAME "$libdir/lib${MOBILITYDB_LIB_NAME}")
set(extschema "@extschema@")

configure_file(mobilitydb.control ${CMAKE_BINARY_DIR}/mobilitydb.control)

macro(process_file f srcdir bindir)
  file(READ ${srcdir}/${f}.in.sql CURR_CONTENTS)

  if (${POSTGRESQL_VERSION_NUMBER} GREATER_EQUAL 130000)
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 130000" "-- if POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 130000" "-- endif POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 130000" "/* --if POSTGRESQL_VERSION_NUMBER < 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 130000" "-- endif POSTGRESQL_VERSION_NUMBER < 130000 */" CURR_CONTENTS "${CURR_CONTENTS}")
  else()
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 130000" "/* -- if POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 130000" "-- endif POSTGRESQL_VERSION_NUMBER >= 130000 */" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 130000" " -- if POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 130000" "-- endif POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
  endif()

  if (${POSTGRESQL_VERSION_NUMBER} GREATER_EQUAL 140000)
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 140000" "-- if POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 140000" "-- endif POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 140000" "/* --if POSTGRESQL_VERSION_NUMBER < 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 140000" "-- endif POSTGRESQL_VERSION_NUMBER < 140000 */" CURR_CONTENTS "${CURR_CONTENTS}")
  else()
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 140000" "/* -- if POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 140000" "-- endif POSTGRESQL_VERSION_NUMBER >= 140000 */" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 140000" " -- if POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 140000" "-- endif POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
  endif()

  if (${POSTGRESQL_VERSION_NUMBER} GREATER_EQUAL 160000)
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 160000" "-- if POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 160000" "-- endif POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 160000" "/* --if POSTGRESQL_VERSION_NUMBER < 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 160000" "-- endif POSTGRESQL_VERSION_NUMBER < 160000 */" CURR_CONTENTS "${CURR_CONTENTS}")
  else()
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 160000" "/* -- if POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 160000" "-- endif POSTGRESQL_VERSION_NUMBER >= 160000 */" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 160000" " -- if POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 160000" "-- endif POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
  endif()

  file(WRITE ${bindir}/${f}.sql.in "${CURR_CONTENTS}")
endmacro()

add_subdirectory(general)
add_subdirectory(point)
if(NPOINT)
  add_subdirectory(npoint)
endif()

list(SORT PROJECT_SQL_FILES)

add_custom_target(all_sql_files ALL
  DEPENDS ${PROJECT_SQL_FILES})

if (PROJECT_VERBOSE)
  message(STATUS "PROJECT_SQL_FILES=${PROJECT_SQL_FILES}")
endif()

foreach (f ${PROJECT_SQL_FILES})
  file(READ ${f} CURR_CONTENTS)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}.in "${CURR_CONTENTS}")
endforeach()

configure_file(${CMAKE_CURRENT_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}.in ${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE} COPYONLY)

# Set the library name extension according to the platform
if(WIN32)
  set(LIB_NAME_EXT ".dll")
else()
  set(LIB_NAME_EXT ".so")
endif()
message(STATUS "Library name extension: '${LIB_NAME_EXT}'")

file(READ "${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}" sql_commands)
string(REPLACE "MODULE_PATHNAME" "${CMAKE_BINARY_DIR}/lib${MOBILITYDB_LIB_NAME}${LIB_NAME_EXT}" sql_commands "${sql_commands}")
message(STATUS "Substitution: ${CMAKE_BINARY_DIR}/lib${MOBILITYDB_LIB_NAME}${LIB_NAME_EXT}")
string(REPLACE "@extschema@" "public" sql_commands "${sql_commands}")

=== postgis/liblwgeom/CMakeLists.txt ===
# if(NOT MEOS)
  # set(lwgeom_transform.c lwgeom_transform.c)
# endif()

add_library(liblwgeom OBJECT
  bytebuffer.c
  effectivearea.c
  gbox.c
  gserialized.c
  gserialized1.c
  gserialized2.c
  lookup3.c
  lwalgorithm.c
  lwboundingcircle.c
  lwchaikins.c
  lwcircstring.c
  lwcollection.c
  lwcompound.c
  lwcurvepoly.c
  lwgeodetic.c
  lwgeodetic_tree.c
  lwgeom.c
  lwgeom_api.c
  lwgeom_debug.c
  lwgeom_functions_analytic.c
  lwgeom_geos.c
  lwgeom_geos_clean.c
  lwgeom_geos_cluster.c
  lwgeom_geos_node.c
  lwgeom_geos_split.c
  lwgeom_median.c
  lwgeom_topo.c
  lwgeom_transform.c
  lwgeom_wrapx.c
  lwhomogenize.c
  lwin_encoded_polyline.c
  lwin_geojson.c
  lwin_twkb.c
  lwin_wkb.c
  lwin_wkt.c
  lwin_wkt_lex.c
  lwin_wkt_parse.c
  lwiterator.c
  lwkmeans.c
  lwline.c
  lwlinearreferencing.c
  lwmcurve.c
  lwmline.c
  lwmpoint.c
  lwmpoly.c
  lwmsurface.c
  lwmval.c
  lwout_encoded_polyline.c
  lwout_geojson.c
  lwout_gml.c
  lwout_kml.c
  lwout_svg.c
  lwout_twkb.c
  lwout_wkb.c
  lwout_wkt.c
  lwout_x3d.c
  lwpoint.c
  lwpoly.c
  lwprint.c
  lwpsurface.c
  lwrandom.c
  lwspheroid.c
  lwstroke.c
  lwtin.c
  lwtree.c
  lwtriangle.c
  lwunionfind.c
  lwutil.c
  measures.c
  measures3d.c
  ptarray.c
  stringbuffer.c
  varint.c
  )

set_property(TARGET liblwgeom PROPERTY C_VISIBILITY_PRESET hidden)
set_property(TARGET liblwgeom PROPERTY POSITION_INDEPENDENT_CODE ON)

=== postgis/liblwgeom/Makefile ===
#/**********************************************************************
# *
# * PostGIS - Spatial Types for PostgreSQL
# * http://postgis.net
# *
# * PostGIS is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * PostGIS is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with PostGIS.  If not, see <http://www.gnu.org/licenses/>.
# *
# **********************************************************************
# *
# * Copyright 2008 Mark Cave-Ayland
# *
# **********************************************************************/

CC = gcc
RYU_INCLUDE = -I../deps/ryu/..
CPPFLAGS =  $(RYU_INCLUDE)  -I/usr/include   -I/usr/include/libxml2  -I/usr/include/json-c  -DNDEBUG 
CFLAGS = -std=gnu99 -g -O0 -fno-math-errno -fno-signed-zeros  -fPIC -DPIC
LDFLAGS =  -lm -L/usr/lib/x86_64-linux-gnu -lgeos_c -lproj -ljson-c
top_builddir = ..
prefix = /usr/local/pgsql/13
exec_prefix = ${prefix}
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include
SHELL = /bin/bash
INSTALL = /usr/bin/install -c
LIBTOOL = $(SHELL) $(top_builddir)/libtool

SOVER = 3.1

IFACE_CURRENT = 0
IFACE_AGE = 0
IFACE_REV = 0

VERSION_INFO = $(IFACE_CURRENT):$(IFACE_REV):$(IFACE_AGE)


YACC=/usr/bin/bison
LEX=flex

# Standalone LWGEOM objects
SA_OBJS = \
	stringbuffer.o \
	bytebuffer.o \
	measures.o \
	measures3d.o \
	ptarray.o \
	lookup3.o \
	lwgeom_api.o \
	lwgeom.o \
	lwpoint.o \
	lwline.o \
	lwpoly.o \
	lwtriangle.o \
	lwmpoint.o \
	lwmline.o \
	lwmpoly.o \
	lwboundingcircle.o \
	lwcollection.o \
	lwcircstring.o \
	lwcompound.o \
	lwcurvepoly.o \
	lwmcurve.o \
	lwmsurface.o \
	lwpsurface.o \
	lwtin.o \
	lwout_wkb.o \
	lwin_geojson.o \
	lwin_wkb.o \
	lwin_twkb.o \
	lwiterator.o \
	lwgeom_median.o \
	lwout_wkt.o \
	lwout_twkb.o \
	lwin_wkt_parse.o \
	lwin_wkt_lex.o \
	lwin_wkt.o \
	lwin_encoded_polyline.o \
	lwutil.o \
	lwhomogenize.o \
	lwalgorithm.o \
	lwstroke.o \
	lwlinearreferencing.o \
	lwprint.o \
	gbox.o \
	gserialized.o \
	gserialized1.o \
	gserialized2.o \
	lwgeodetic.o \
	lwgeodetic_tree.o \
	lwrandom.o \
	lwtree.o \
	lwout_gml.o \
	lwout_kml.o \
	lwout_geojson.o \
	lwout_svg.o \
	lwout_x3d.o \
	lwout_encoded_polyline.o \
	lwgeom_debug.o \
	lwgeom_geos.o \
	lwgeom_geos_clean.o \
	lwgeom_geos_cluster.o \
	lwgeom_geos_node.o \
	lwgeom_geos_split.o \
	lwgeom_topo.o \
	lwgeom_transform.o \
	lwgeom_wrapx.o \
	lwunionfind.o \
	effectivearea.o \
	lwchaikins.o \
	lwmval.o \
	lwkmeans.o \
	varint.o

NM_OBJS = \
	lwspheroid.o

ifeq (,sfcgal)
CFLAGS += 
LDFLAGS += 
SA_OBJS += lwgeom_sfcgal.o
endif

LDFLAGS += -no-undefined

LT_SA_OBJS = $(SA_OBJS:.o=.lo)
LT_NM_OBJS = $(NM_OBJS:.o=.lo)
LT_OBJS = $(LT_SA_OBJS) $(LT_NM_OBJS)

SA_HEADERS = \
	bytebuffer.h \
	effectivearea.h \
	liblwgeom.h \
	liblwgeom_internal.h \
	lwgeodetic.h \
	lwgeodetic_tree.h \
	liblwgeom_topo.h \
	liblwgeom_topo_internal.h \
	lwgeom_log.h \
	lwgeom_geos.h \
	lwgeom_log.h \
	lwgeom_sfcgal.h \
	lwinline.h \
	lwin_wkt.h \
	lwin_wkt_parse.h \
	lwout_twkb.h \
	lwrandom.h \
	lwtree.h \
	measures3d.h \
	measures.h \
	stringbuffer.h \
	varint.h

all: liblwgeom.la

install:

uninstall:

# Make all objects depend upon postgis_config.h and postgis_revision.h
$(LT_OBJS): ../postgis_config.h ../postgis_revision.h $(SA_HEADERS)

../postgis_revision.h:
	$(MAKE) -C .. postgis_revision.h


RYU_LIBPATH = ../deps/ryu/libryu.la
$(RYU_LIBPATH): ../deps/ryu/d2s.c
	$(MAKE) -C ../deps/ryu libryu.la

liblwgeom.la: $(LT_OBJS) $(RYU_LIBPATH)
	$(LIBTOOL) --tag=CC --mode=link $(CC) -rpath $(libdir) $(LT_OBJS) $(RYU_LIBPATH)\
             -release $(SOVER) -version-info $(VERSION_INFO) $(LDFLAGS) -static -o $@

maintainer-clean: clean
	rm -f lwin_wkt_lex.c
	rm -f lwin_wkt_parse.h
	rm -f lwin_wkt_parse.c

clean:
	$(MAKE) -C cunit clean
	$(MAKE) -C ../deps/ryu clean
	rm -f $(LT_OBJS) $(SA_OBJS) $(NM_OBJS)
	rm -f liblwgeom.la
	rm -rf .libs

distclean: clean
	$(MAKE) -C cunit distclean
	rm -f liblwgeom.h Makefile

check: check-unit

check-regress:

.PHONY: check-unit
check-unit: liblwgeom.la
	$(MAKE) -C cunit check

# Command to build each of the .lo files
$(LT_SA_OBJS): %.lo: %.c
	$(LIBTOOL) --mode=compile $(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

$(LT_NM_OBJS): %.lo: %.c
	$(LIBTOOL) --mode=compile $(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

lwin_wkt_parse.c lwin_wkt_parse.h: lwin_wkt_parse.y
	@test -n "$(YACC)" || { \
			echo "No yacc found, cannot build parser" >&2; \
			false; \
	}
	$(YACC) -p wkt_yy -o'lwin_wkt_parse.c' -d lwin_wkt_parse.y

lwin_wkt_lex.c: lwin_wkt_lex.l
	@test -n "$(LEX)" || { \
			echo "No lex found, cannot build parser" >&2; \
			false; \
	}
	$(LEX) -i lwin_wkt_lex.l

liblwgeom.h: liblwgeom.h.in
	cd .. && ./config.status

=== meos/postgres/port/CMakeLists.txt ===
add_library(port OBJECT
  pg_bitutils.c
  pgstrcasecmp.c
  qsort.c
  qsort_arg.c
  snprintf.c
  )

set_property(TARGET port PROPERTY C_VISIBILITY_PRESET hidden)
set_property(TARGET port PROPERTY POSITION_INDEPENDENT_CODE ON)

=== meos/postgres/timezone/CMakeLists.txt ===
add_library(timezone OBJECT
  findtimezone.c
  localtime.c
  pgtz.c
  )

set_property(TARGET timezone PROPERTY C_VISIBILITY_PRESET hidden)
set_property(TARGET timezone PROPERTY POSITION_INDEPENDENT_CODE ON)

=== meos/src/general/CMakeLists.txt ===
add_library(general OBJECT
  doublen.c
  error.c
  lifting.c
  meos.c
  meos_catalog.c
  pg_types.c
  skiplist.c
  set.c
  set_ops.c
  span.c
  span_aggfuncs.c
  span_ops.c
  spanset.c
  spanset_ops.c
  tbool_boolops.c
  tbox.c
  temporal.c
  temporal_aggfuncs.c
  temporal_analytics.c
  temporal_boxops.c
  temporal_compops.c
  temporal_modif.c
  temporal_restrict.c
  temporal_tile.c
  temporal_waggfuncs.c
  tinstant.c
  tnumber_distance.c
  tnumber_mathfuncs.c
  tsequence.c
  tsequenceset.c
  ttext_textfuncs.c
  type_in.c
  type_out.c
  type_parser.c
  type_round.c
  type_util.c
)

add_library(general_meos OBJECT
  set_aggfuncs_meos.c
  span_aggfuncs_meos.c
  tbool_boolops_meos.c
  temporal_boxops_meos.c
  temporal_compops_meos.c
  temporal_meos.c
  temporal_posops_meos.c
  tnumber_mathfuncs_meos.c
  ttext_textfuncs_meos.c
)

=== meos/src/point/CMakeLists.txt ===
add_library(point OBJECT
  pgis_types.c
  stbox.c
  tpoint.c
  tpoint_aggfuncs.c
  tpoint_boxops.c
  tpoint_boxops_meos.c
  tpoint_compops.c
  tpoint_distance.c
  tpoint_out.c
  tpoint_parser.c
  tpoint_posops_meos.c
  tpoint_restrict.c
  tpoint_datagen.c
  tpoint_spatialfuncs.c
  tpoint_spatialrels.c
  tpoint_tempspatialrels.c
  tpoint_tile.c
  type_srid.c
)

=== debian/changelog ===
mobilitydb (1.1.1-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 07 May 2024 17:00:40 +0200

mobilitydb (1.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1037101)

 -- Bradford D. Boyle <bradford.d.boyle@gmail.com>  Tue, 07 May 2024 17:00:40 +0200

=== debian/control ===
Source: mobilitydb
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Bradford D. Boyle <bradford.d.boyle@gmail.com>,
Build-Depends:
 debhelper (>= 12),
 postgresql-all (>= 256~),
 cmake,
 libgeos-dev,
 libgsl-dev,
 libjson-c-dev,
 libproj-dev,
 postgresql-12-postgis-3, postgresql-13-postgis-3, postgresql-14-postgis-3, postgresql-15-postgis-3, postgresql-16-postgis-3,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://mobilitydb.com/
Vcs-Browser: https://salsa.debian.org/postgresql/MobilityDB
Vcs-Git: https://salsa.debian.org/postgresql/MobilityDB.git

Package: postgresql-12-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-12-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-13-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-13-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-14-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-14-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-15-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-15-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-16-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-16-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

=== debian/tests/control ===
Depends:
 cmake,
 g++,
 libgeos-dev,
 libgsl-dev,
 libjson-c-dev,
 libproj-dev,
 make,
 postgresql-16-postgis-3,
 xz-utils,
 @,
Tests: installcheck
Restrictions: allow-stderr
